<?php
# Format of XML file from V7000 (and/or SVC)
#
#Per-node Mdisk Statistics collected
# Taken from https://www-304.ibm.com/support/docview.wss?uid=ssg1S1003597&wv=1
#
#The abbreviation in brackets ()’s is the tag used within the XML file which the statistic is reported in.
#
#Per Mdisk identification
#
#    Mdisk ID (idx)
#    Mdisk name (id)
#
#
#Per MDisk Read/write counters
#
#    Per MDisk Read operations (ro)
#    Per MDisk Write operations (wo)
#    Per MDisk Read blocks (512 bytes) (rb)
#    Per MDisk Write blocks (512 bytes) (wb)
#
#
#Note: The per node performance statistics do include retries which occur as a result of errors occurring on 
#  the SVC to backend controller path. Thus, if a read or write needs to be retried several times, each retry is accounted for.
#
#Per MDisk Cumulative response times
#
#    Per MDisk Cumulative Read external response time in milliseconds. (re)
#    This is the cumulative response times for disk reads sent to the managed disk. That is to say that for each SCSI Read command 
#    sent to the Managed disk, a timer is started when the command is issued across the fibre channel. When the command completes, 
#    the elapsed time since it was started is added to the cumulative counter for this direction.
#    Per MDisk Cumulative write external response time (we)
#    As above but for write commands.
#    Per MDisk Cumulative Read queued response time (rq)
#    This is the cumulative response time measured above the queue of commands waiting to be sent to an MDisk because it’s queue is already full.
#    Per MDisk Cumulative write queued response time (wq)
#    As above but for write commands.
#    Per MDisk cumulative read external response time in microseconds (ure)
#    These microsecond statistics are calculated in the same way as the millisecond statistics but are reported in microseconds
#
#    Per MDisk cumulative write external response time in microseconds (uwe)
#    Per MDisk cumulative read queued response time in microseconds (urq)
#    Per MDisk cumulative write queued response time in microseconds (uwq)
#    Per MDisk peak read external response time in microseconds (pre)
#    This is the peak read response time measured on the fabric during the interval since the last collection. This is not cumulative, 
#    it is a single specific value that shows the maximum read response time during the last interval. It requires no manipulation.
#
#    Per MDisk peak write external response time in microseconds (pwe)
#    As above for writes.
#
#    Per MDisk peak read queued response time in microseconds (pro)
#    This is the peak read response time measured above the queue of commands waiting to be sent to an Mdisk because it’s queue 
#    depth is already full. It includes the time spent in the queue and the time spent being executed by the storage controller.
#    This is not cumulative, it is a single specific value that shows the maximum read response time during the last interval of 
#    collection. It requires no manipulation.
#    Per MDisk peak write queued response time in microseconds (pwo)
#    As above for writes
#
#
#Note: The per node performance statistics do include retries which occur as a result of errors occurring on the SVC to backend controller path. Thus, if a read or write needs to be retried several times, each retry accumulates response time. 


# all required input parms
$hostname       	= $_SERVER["argv"][1];
$cmd            	= $_SERVER["argv"][2];
if (isset($_SERVER["argv"][3])) { $query_field = $_SERVER["argv"][3]; };
if (isset($_SERVER["argv"][4])) { $query_index = $_SERVER["argv"][4]; };


$xml_delimiter          =  "!";

exec("ls /svcmon/iostats/$hostname/Nm*|sort|tail -1", $output_arr);
$xml = simplexml_load_file("$output_arr[0]");

#foreach($xml->mdsk[0]->attributes() as $a => $b) {
    #echo $a,'="',$b,"\"\n";
#}

# This will output the index number of each mdsk
if ($cmd == "index") {
  foreach ($xml->children() as $node) {
    $arr = $node->attributes();   // returns an array
    print ($arr["idx"]."\n");     // get the value of this attribute
  }
}elseif ($cmd == "query") {

 foreach ($xml->children() as $node) {
    $arr = $node->attributes();   // returns an array
    if ($query_field == "index") { $query_field = "idx"; }
    print ($arr["idx"] . $xml_delimiter . $arr[$query_field] . "\n");     // get the value of this attribute
  }
}elseif ($cmd == "get") {
  if ($query_field == "index") { $query_field = "idx"; }
//  print $xml->mdsk[(int)$query_index][$query_field] ;
  foreach ($xml->children() as $node) {
    //$arr = $node->attributes();   // returns an array
   // print_r($arr["wb"] );
   $currIndex = (int)$node->attributes()->idx;
   //print $currIndex . " Q: " . $query_index . " F: " . $node->attributes()->wb . "\n";
    if ($currIndex == $query_index) { print $node->attributes()->$query_field; }
    //if ($arr["idx"]->idx = $query_index) { print ( $arr["rb"]  ); }
    //if ($arr["idx"] = $query_index) { print ( $arr["idx"]  ); }
    //print ($arr["idx"]."\n");     // get the value of this attribute
  }

}

?>
