<?php
# Format of XML file from V7000 (and/or SVC)
#
#Per-node CPU Statistics collected
# Taken from https://www-304.ibm.com/support/docview.wss?uid=ssg1S1003597&wv=1
#
#This statistic reports the pseudo-CPU utilisation. On an SVC, if we reported 
# the CPU utilisation that is reported by the operating system, then it would 
# show 100% because SVC polls the fibre-channel if there is nothing to do. What 
# this statistic reports is the amount of the time the processor has spent polling 
# waiting for work versus actually doing work.
#
#In the file the statistic which is reported is:
#
#    The number of busy milliseconds since the node was reset (busy)
#
#
#Thus this figure accumulates from zero. For a totally idle node the number will 
# stay at zero (this would never happen) for a totally busy node the number will 
# accumulate at 1000 per second. 


# all required input parms
$hostname       	= $_SERVER["argv"][1];
$cmd            	= $_SERVER["argv"][2];
if (isset($_SERVER["argv"][3])) { $query_field = $_SERVER["argv"][3]; };
if (isset($_SERVER["argv"][4])) { $query_index = $_SERVER["argv"][4]; };


$xml_delimiter          =  "!";

exec("ls /svcmon/iostats/$hostname/Nn*|sort|tail -1", $output_arr);
$xml = simplexml_load_file("$output_arr[0]");

# This will output the index number of each cpu. Since the v7000 XML 
#  file reports only one, we will just hard code the output.
if ($cmd == "index") {
    print("1\n");

}elseif ($cmd == "query") {
 if ($query_field == "index") { 
    print ("1" . $xml_delimiter . "1\n");
 }else
    foreach ($xml->children()->cpu as $node) {
      $arr = $node->attributes();   // returns an array
      print ("1" . $xml_delimiter . $arr[$query_field] . "\n");     // get the value of this attribute
 }
}elseif ($cmd == "get") {
 if ($query_field == "index") { 
    print ("1");
 }else
   foreach ($xml->children()->cpu as $node) {
    print $node->attributes()->$query_field; 
  }
}

?>
